"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "useFormValues", {
  enumerable: true,
  get: function get() {
    return _reactForms.useFormValues;
  }
});
exports.Select = exports.Radio = exports.RadioButton = exports.Checkbox = exports.Text = exports.Button = exports.Submit = exports.Form = exports.ErrorMessage = void 0;

var _react = require("react");

var _reactForms = require("@cordelta/react-forms");

var _ErrorMessage = require("@cordelta/react-forms/dist/ErrorMessage");

var core = _interopRequireWildcard(require("@material-ui/core"));

require("./styles");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ErrorMessage = function ErrorMessage(_ref) {
  var error = _ref.error;
  return /*#__PURE__*/(0, _react.createElement)(core.FormHelperText, {
    children: (0, _ErrorMessage.extractErrorMessage)(error),
    error: true
  });
};

exports.ErrorMessage = ErrorMessage;
var Form = (0, _reactForms.FormProvider)(_reactForms.context.Provider, {
  margin: 'normal'
}, ErrorMessage);
exports.Form = Form;
var Submit = (0, _reactForms.wrapSubmit)(core.Button);
exports.Submit = Submit;
var Button = core.Button;
exports.Button = Button;

var wrapped = function wrapped(component, options, baseOptions) {
  return (0, _reactForms.wrapInput)(base(component, options, baseOptions), _objectSpread({
    passErrorProp: true
  }, options));
};

var base = function base(component) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var _ref2 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
      alwaysShrinkLabel = _ref2.alwaysShrinkLabel,
      _ref2$shrinkLabel = _ref2.shrinkLabel,
      shrinkLabel = _ref2$shrinkLabel === void 0 ? true : _ref2$shrinkLabel;

  return function (_ref3) {
    var className = _ref3.className,
        error = _ref3.error,
        hiddenLabel = _ref3.hiddenLabel,
        variant = _ref3.variant,
        margin = _ref3.margin,
        label = _ref3.label,
        helperText = _ref3.helperText,
        inputProps = _objectWithoutProperties(_ref3, ["className", "error", "hiddenLabel", "variant", "margin", "label", "helperText"]);

    return /*#__PURE__*/(0, _react.createElement)(core.FormControl, {
      className: "react-forms-material-field".concat(options.type ? " react-forms-material-".concat(options.type) : '').concat(className ? " ".concat(className) : ''),
      error: error,
      fullWidth: inputProps.fullWidth,
      hiddenLabel: hiddenLabel,
      required: inputProps.required,
      variant: variant,
      margin: margin,
      children: [].concat(_toConsumableArray(label ? [/*#__PURE__*/(0, _react.createElement)(core.InputLabel, _objectSpread(_objectSpread({
        key: 'label',
        htmlFor: inputProps.id,
        children: label
      }, shrinkLabel === false && {
        shrink: false
      }), alwaysShrinkLabel && {
        className: 'MuiInputLabel-shrink'
      }))] : []), [/*#__PURE__*/(0, _react.createElement)(component, _objectSpread({
        key: 'input'
      }, inputProps))], _toConsumableArray(helperText ? [/*#__PURE__*/(0, _react.createElement)(core.FormHelperText, {
        key: 'helperText',
        children: helperText
      })] : []))
    });
  };
};

var Text = wrapped(core.Input);
exports.Text = Text;
var Checkbox = wrapped(core.Checkbox, {
  type: 'checkbox'
}, {
  alwaysShrinkLabel: true
});
exports.Checkbox = Checkbox;
var RadioButton = wrapped(core.Radio, {
  type: 'radio'
}, {
  shrinkLabel: false
});
exports.RadioButton = RadioButton;
var Radio = (0, _reactForms.createRawConsumer)(base(function (_ref4) {
  var name = _ref4.name,
      values = _ref4.values,
      labels = _ref4.labels,
      numeric = _ref4.numeric,
      required = _ref4.required,
      props = _objectWithoutProperties(_ref4, ["name", "values", "labels", "numeric", "required"]);

  return /*#__PURE__*/(0, _react.createElement)(core.RadioGroup, _objectSpread(_objectSpread({}, props), {}, {
    children: [values.map(function (value, index) {
      return /*#__PURE__*/(0, _react.createElement)(RadioButton, _objectSpread({
        name: name,
        value: value,
        numeric: numeric,
        key: value,
        label: labels && labels[index] || value,
        margin: props.margin
      }, required && {
        required: required
      }));
    })]
  }));
}, {
  type: 'radiogroup'
}, {
  alwaysShrinkLabel: true
}));
exports.Radio = Radio;
var Select = wrapped(function (_ref5) {
  var values = _ref5.values,
      labels = _ref5.labels,
      props = _objectWithoutProperties(_ref5, ["values", "labels"]);

  return /*#__PURE__*/(0, _react.createElement)(core.Select, _objectSpread(_objectSpread({}, props), {}, {
    children: values.map(function (value, index) {
      return /*#__PURE__*/(0, _react.createElement)(core.MenuItem, _objectSpread({
        value: value,
        key: value,
        children: labels && labels[index] || value
      }, props.required && {
        required: props.required
      }));
    })
  }));
}, {
  type: 'select'
}, {
  alwaysShrinkLabel: true
});
exports.Select = Select;